Subject: RE: [lemonade] Compression: TLS or Application-layer

From: Eric Burger <[email-masked]>
Date: Wed, 29 Sep 2004 09:03:09 -0400

<chair-hat-off>

Is gzip less expensive than TLS with null cipher?.  TLS works on the stream
(e.g., 8KB or pick your favorite size) at a time, not on the entire message
(including data).  This could very well result in fewer instructions,
meaning less battery drain.  That said, that is why I was wondering about
the compression performance of TLS vs. gzip.

I also have serious protocol issues with application-layer compression.
Today we might like gzip.  Tomorrow we might like ZIP (ignoring IPR
issues...).  The day after we might want FOOBAR.  After that, BARFOO takes
hold.  Service provider Z wants to use their proprietary compression
program.  That means the protocol needs to support application-layer
compression method negotiation.  TLS, SIGCOMP, et al. have solved this
already.

</chair-hat-off>

> -----Original Message-----
> From: Arnt Gulbrandsen [mailto:[email-masked]]
> Sent: Tuesday, September 28, 2004 12:19 PM
> To: [email-masked]
> Subject: Re: [lemonade] Compression: TLS or Application-layer
> 
> 
> [email-masked] writes:
> > From an operator's perspective, any feature which reduces bandwidth 
> > performance is a good thing.  So they would want compression at any 
> > level.
> > However, TLS connections over GPRS networks tend to be expensive to 
> > setup and difficult to maintain (at least today).
> 
> If you use the null cipher, that shouldn't be the case.
> 
> > Another consideration is battery drain.  TLS connections 
> tend to be a 
> > big load on the battery because of the computational power required 
> > to decrypt + decompress the stream.  App level compression would 
> > improve battery life, but would still require more power than no 
> > compression at all.
> 
> Right. But you can get the same from TLS by using the null cipher.
> 
> ...
> > In the end we need to make mobile email as painless as 
> possible, and 
> > forcing TLS to compress email will make mobile email clients more 
> > unwieldy than they already are.
> 
> Do you want to know my neighbour's password? I don't know which 
> neighbour it is - just someone whose WLAN AP covers my living room. I 
> know he/she uses IMAP, I'll bet I could see both password and lots of 
> juicy private mail.
> 
> If you insist on "NO TLS!" on wireless devices, then you're 
> forcing your 
> customers' email out into the open, where nasties like me can listen, 
> and that's going to be painful for your customers. On the other hand, 
> if you use TLS, then you can either use the null cipher for better 
> battery lifetime, or you can use real crypto.
> 
> Arnt
> 
> _______________________________________________
> lemonade mailing list
> [email-masked]
> https://www1.ietf.org/mailman/listinfo/lemonade
> 

_______________________________________________
lemonade mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/lemonade

---

From: Arnt Gulbrandsen <[email-masked]>
Date: Wed, 29 Sep 2004 15:51:51 +0200

Eric Burger writes:
> <chair-hat-off>
>
> Is gzip less expensive than TLS with null cipher?.

Effectively it's the same in terms of CPU. There are minor differences 
wrt. data formats and padding.

> TLS works on the stream (e.g., 8KB or pick your favorite size) at a 
> time, not on the entire message (including data). This could very 
> well result in fewer instructions, meaning less battery drain. That 
> said, that is why I was wondering about the compression performance 
> of TLS vs. gzip.

They both using the algorithm from RFC 1950. The wrapping is different, 
but that's small details. GZIP uses RFC1952 wrapping, TLS RFC 1951. Or 
the other way around.

(I don't remember any 8k block, btw. I seem to remember a 16-byte block 
somewhere in TLS, and of course there is the LZ77 rolling window in RFC 
1950.)

Arnt